/*
    Pushmo Checksum Patcher
    By Virus - Game-Hackers.com, debugroom.com

    Special thanks:
        -   Vash - Game-Hackers.com
        -   http://www.cosc.canterbury.ac.nz/greg.ewing/essays/CRC-Reverse-Engineering.html
        -   http://miscel.dk/MiscEl/CRCcalculations.html
*/

#include <stdio.h>

unsigned long crc32(unsigned char *data, int start, int len)
{
    unsigned long poly = 0x04C11DB7;
    unsigned long crc = 0, temp;
    int i, j;

    for(i = start; i < start + len; i++) {
        temp = (((crc >> 24) ^ data[i]) & 0xFF) << 24;

        for(j = 0; j < 8; j++)
            temp & 0x80000000? (temp = (temp << 1) ^ poly) : (temp <<= 1);

        crc = (crc << 8) ^ temp;
    }

    return crc ^ 0xD87A2314;
}

int main(int argv, char *args[])
{
    int len = 0x2CE;
    unsigned long crc;
    unsigned char data[len];
    FILE *fp;

    printf("Pushmo Checksum Patcher v1.0\nCreated by Virus - Game-Hackers.com\n\n");

    if(argv != 2) {
        printf("Usage: pushmo_patcher.exe <file>\n");
        return 0;
    }


    fp = fopen(args[1], "rb+");

    if(fp == NULL) {
        printf("Unable to open the specified file!\n");
        return 0;
    }

    fseek(fp, 0, SEEK_END);
    if(ftell(fp) != len) {
        printf("Invalid file!\n");
        return 0;
    }

    fseek(fp, 0, SEEK_SET);
    if(fread(data, 1, len, fp) != len) {
        printf("Unable to read the file!\n");
        return 0;
    }

    crc = crc32(data, 0xC, 0x2C2);

    fseek(fp, 8, SEEK_SET);
    if(fwrite(&crc, 1, sizeof(crc), fp) == sizeof(crc)) {
        printf("Checksum patched!\n");
    }
    fclose(fp);

    return 0;
}
